department-app/flask_department/models/models.py
from flask_department import db


class Department(db.Model):
    __tablename__ = 'departments'
    id = db.Column(db.Integer, primary_key=True)
    department = db.Column(db.String(45), nullable=False)

    employees = db.relationship('Employee', backref='dep_name')

    def __init__(self, department):
        self.department = department

    def __repr__(self):
        return f'{self.department}'


class Employee(db.Model):
    __tablename__ = 'employees'
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(45), nullable=False)
    dob = db.Column(db.Date, nullable=False)
    salary = db.Column(db.Integer, nullable=False)

    dep_id = db.Column(db.Integer, db.ForeignKey('departments.id'))

    def __init__(self, name, dob, salary, dep_name):
        self.name = name
        self.dob = dob
        self.salary = salary
        self.dep_name = dep_name

    def __repr__(self):
        return f'{self.name}'

department-app/flask_department/__init__.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_migrate import Migrate
from flask_restful import Api

app = Flask(__name__)
app.config.from_object('config.ProductionConfig')
db = SQLAlchemy(app)
migrate = Migrate(app, db)
api = Api(app)

department-app/flask_department/views/home.py
from flask import render_template, Blueprint

bp = Blueprint('home', __name__)


@bp.route('/')
@bp.route('/home')
def index():
    return render_template('index.html')

department-app/flask_department/views/list_departments.py
from flask import request, redirect, url_for, flash, render_template, Blueprint
from flask_department.models.models import Employee, Department
from flask_department import db
bp = Blueprint('list_departments', __name__)


@bp.route('/ls_dep')
def ls_dep():
    average_salary = {}
    for dep in Department.query.all():
        avg_salary = db.session.query(db.func.round(db.func.avg(Employee.salary))).filter(
            Employee.dep_id == dep.id)
        average_salary.update({dep: avg_salary[0][0]})
    return render_template('ls_dep.html', average_salary=average_salary.items())


@bp.route('/new-dep/', methods=['POST'])
def new_dep():
    if request.method == 'POST':
        name = request.form['new-dep']
        data = Department(name)
        db.session.add(data)
        db.session.commit()

        flash('Department was successfully added')

        return redirect(url_for('list_departments.ls_dep'))


@bp.route('/edit-dep/', methods=['POST'])
def edit_dep():
    if request.method == 'POST':
        dep = Department.query.get(request.form.get('id'))
        dep.department = request.form['dep-name-edit']
        db.session.commit()

        flash('Department was successfully edited')

        return redirect(url_for('list_departments.ls_dep'))


@bp.route('/del-dep/<id_dep>', methods=['POST'])
def del_dep(id_dep):
    dep_id = Department.query.get(id_dep)
    db.session.delete(dep_id)
    db.session.commit()

    flash('Department was successfully deleted')

    return redirect(url_for('list_departments.ls_dep'))

department-app/flask_department/views/list_employees.py
from flask import render_template, Blueprint
from flask_department.models.models import Employee, Department
from flask_department import db

bp = Blueprint('list_employees', __name__)


@bp.route('/ls_emp')
def ls_emp():
    counter = {}
    info_list = []
    for dep in Department.query.all():
        emp_counter = db.session.query(Employee).filter(Employee.dep_id == dep.id).count()
        dep_names = dep.department
        emp_info = Employee.query.filter(Employee.dep_id == dep.id).all()

        counter.update({dep_names: emp_counter})
        info_list.append(emp_info)
    return render_template('ls_emp.html', counter=counter, info_list=info_list)

department-app/flask_department/views/search.py
from flask import request, redirect, url_for, flash, render_template, Blueprint
from flask_department.models.models import Employee, Department
from flask_department import db

bp = Blueprint('search', __name__)


@bp.route('/search')
def search():
    data = Department.query.all()
    return render_template('search.html', all_dep=data)


@bp.route('/insert', methods=['POST'])
def insert():
    if request.method == 'POST':
        name = request.form['name']
        dep_name = Department.query.filter_by(department=request.form['department']).first()
        salary = request.form['salary']
        dob = request.form['dob-emp']

        data = Employee(name, dob, salary, dep_name)
        db.session.add(data)
        db.session.commit()

        flash('User was successfully added')

        return redirect(url_for('search.search'))


@bp.route('/edit/', methods=['GET', 'POST'])
def edit():
    if request.method == 'POST':
        data = Employee.query.get(request.form.get('id'))
        data.name = request.form['name']
        data.dob = request.form['dob-emp']
        data.salary = request.form['salary']
        data.dep_name = Department.query.filter_by(department=request.form['department-edit']).first()
        db.session.commit()

        flash('User was successfully edited')

        return redirect(url_for('search.search'))


@bp.route('/delete/<id>/', methods=['GET', 'POST'])
def delete(id):
    data = Employee.query.get(id)
    db.session.delete(data)
    db.session.commit()

    flash('User was successfully deleted')

    return redirect(url_for('search.search'))


@bp.route('/search_date', methods=['GET', 'POST'])
def search_date():
    if request.method == 'POST':
        date = request.form['date-dob']

        data = Employee.query.filter(date == Employee.dob).all()
        all_dep = Department.query.all()
        return render_template('search.html', emp_dob_date=data, all_dep=all_dep)


@bp.route('/search_period', methods=['GET', 'POST'])
def search_period():
    if request.method == 'POST':
        period_1 = request.form['period-1']
        period_2 = request.form['period-2']

        all_dep = Department.query.all()
        data = Employee.query.filter(Employee.dob.between(period_1, period_2))
        return render_template('search.html', emp_dob_period=data, all_dep=all_dep)

department-app/flask_department/templates/base.html
<!DOCTYPE html>
<html lang="ru">
<head>
	<title>{% block title %} {% endblock %}</title>
	<link rel="preconnect" href="https://fonts.gstatic.com">
	<!-- EDIT -->
	<link href="https://fonts.googleapis.com/css2?family=Roboto:wght@300&display=swap" rel="stylesheet">
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
	<link rel="stylesheet" type="text/css" href="{{url_for('static', filename='css/style.css')}}">
	<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
</head>
<body>
	<header>
	<nav class="navigation">
		<ul>
			{% block header %} {% endblock %}
	  	</ul>
	</nav>
		<h1 class="logo"><a href="{{url_for('home.index')}}">Department <span class="red">App</span></a></h1>
	</header>
	<section>
		{% block section %} {% endblock %}
	</section>
</body>
</html>

department-app/flask_department/templates/edit.html
<div id="modaledit{{employee.id}}" class="modal fade" role="dialog">
   <div class="modal-dialog">
      <div class="modal-content">

         <div class="modal-header">
            <h4 class="modal-title">Edit Employee</h4>
         </div>

         <div class="modal-body">
            <form action="{{url_for('search.edit')}}" method="POST">
               <div class="form-group">
                  <label for="name">Name:</label>
                   <input type="hidden" name="id" value="{{employee.id}}">
                  <input type="text" id="name" class="form-control" name="name"
                         required="" pattern="^[A-Za-zА-Яа-яЁё\s]+$" value="{{employee.name}}">
               </div>

                <div class="form-group">
                  <label for="department-edit">Department name:</label>
                  <select name="department-edit" id="department-edit" required class="form-control">
                        {% for dep in all_dep %}
                            <option value="{{dep.department}}">{{dep.department}}</option>
                        {% endfor %}
                    </select>
                </div>

                <div class="form-group">
                  <label for="dob-emp">DOB:</label>
                  <input type="date" class="form-control" name="dob-emp" id="dob-emp" required="" value="{{employee.dob}}">
               </div>

                <div class="form-group">
                  <label for="salary">Salary:</label>
                  <input type="number" class="form-control" name="salary" id="salary"
                         required="" min="5000" max="99999" value="{{employee.salary}}">
               </div>

               <div class="form-group">

                  <button class="btn btn-primary" type="submit">Update</button>
               </div>
            </form>
         </div>

         <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
         </div>

      </div>
   </div>
</div>

department-app/flask_department/templates/index.html
{% extends 'base.html' %}

{% block title %} Department app {% endblock %}

<link rel="stylesheet" type="text/css" href="style.css">

{% block header %}
<li><a id="now" href="{{url_for('home.index')}}">Home</a></li><!--
--><li><a href="{{url_for('list_departments.ls_dep')}}">List of departments</a></li><!--
--><li><a href="{{url_for('list_employees.ls_emp')}}">List of employees</a></li><!--
--><li><a href="{{url_for('search.search')}}">&#128269;</a></li>
{% endblock %}

{% block section %}
<div class="image">
	<img src="{{url_for('static', filename='images/office.jpg')}}" alt="Office image" width="1000px">
</div>
{% endblock %}

department-app/flask_department/templates/ls_dep.html
{% extends 'base.html' %}

{% block title %} List of departments {% endblock %}

{% block header %}
<li><a href="{{url_for('home.index')}}">Home</a></li><!--
--><li><a id="now" href="{{url_for('list_departments.ls_dep')}}">List of departments</a></li><!--
--><li><a href="{{url_for('list_employees.ls_emp')}}">List of employees</a></li><!--
--><li><a href="{{url_for('search.search')}}">&#128269;</a></li>
{% endblock %}

{% block section %}
<form action="{{url_for('list_departments.new_dep')}}" class="form-dob" method="post">
    <label for="new-dep">Add new <b>Department</b>:</label>
	<input type="text" name="new-dep" id="new-dep" pattern="^[A-Za-zА-Яа-яЁё\s]+$" required="">
	<input type="submit" class="" name="">
</form>

{% with messages = get_flashed_messages() %}
    {% if messages %}
        {% for message in messages %}
            <div class="alert alert-success alert-dismissable" role="alert">

                <button type="button" class="close" data-dismiss="alert" aria-label="close">
                    <span aria-hidden="true">x</span>
                </button>

                <h4 class="message-flash"><b>{{ message }}</b></h4>
            </div>

        {% endfor %}
    {% endif %}
{% endwith %}

<table>

    <tr>
        <th>Department</th>
		<th>Average  Salary</th>
        <th>Action</th>
    </tr>
    {% for dep_salary in average_salary %}
    <tr>
        <td>{{ dep_salary[0] }}</td>
		<td>{{ dep_salary[1] }}</td>

        <td class="edit">
            <a href="" class="btn btn-warning btn-xs" data-toggle="modal" data-target="#modaledit{{ dep_salary[0].id }}">EDIT</a>
            <a href="/del-dep/{{ dep_salary[0].id }}" class="btn btn-danger btn-xs"
               onclick="return confirm('Are you sure to delete this department?')">DELETE</a>
        </td>
    {% endfor %}
    </tr>
</table>

{% for dep_salary in average_salary %}
<div id="modaledit{{ dep_salary[0].id }}" class="modal fade" role="dialog">
   <div class="modal-dialog">
      <div class="modal-content">

         <div class="modal-header">
            <h4 class="modal-title">Edit <b>Department</b></h4>
         </div>

         <div class="modal-body">
            <form action="{{url_for('list_departments.edit_dep')}}" method="POST">

                <div class="form-group">
                  <label for="dep-name-edit">Department name:</label>
                    <input type="hidden" name="id" value="{{ dep_salary[0].id }}">
                  <input type="text" id="dep-name-edit" class="form-control" name="dep-name-edit"
                          required="" pattern="^[A-Za-zА-Яа-яЁё\s]+$" value="{{ dep_salary[0].department }}">
               </div>

               <div class="form-group">

                  <button class="btn btn-primary" type="submit">Update</button>
               </div>
            </form>
         </div>

         <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
         </div>

      </div>
   </div>
</div>
{% endfor %}

{% endblock %}

department-app/flask_department/templates/ls_emp.html
{% extends 'base.html' %}

{% block title %} List of employees {% endblock %}

{% block header %}
<li><a href="{{url_for('home.index')}}">Home</a></li><!--
--><li><a href="{{url_for('list_departments.ls_dep')}}">List of departments</a></li><!--
--><li><a id="now" href="{{url_for('list_employees.ls_emp')}}">List of employees</a></li><!--
--><li><a href="{{url_for('search.search')}}">&#128269;</a></li>
{% endblock %}

{% block section %}
<table>
	<tr>
		<th>Department</th>
		<th>Employee</th>
		<th>Salary</th>
	</tr>

	{% for emp in info_list %}
		{% for info in emp %}
			{% if info == emp.0 %}
			<tr>
				<td rowspan="{{counter[info.dep_name.department]}}">{{info.dep_name.department}}</td>
				<td>{{info.name}}</td>
				<td>{{info.salary}}</td>
			</tr>
			{% else %}
			<tr>
				<td>{{info.name}}</td>
				<td>{{info.salary}}</td>
			</tr>
			{% endif %}
		{% endfor %}
	{% endfor %}
</table>
{% endblock %}

department-app/flask_department/templates/search.html
{% extends 'base.html' %}

{% block title %} Edit information {% endblock %}

{% block header %}
<li><a href="{{url_for('home.index')}}">Home</a></li><!--
--><li><a href="{{url_for('list_departments.ls_dep')}}">List of departments</a></li><!--
--><li><a href="{{url_for('list_employees.ls_emp')}}">List of employees</a></li><!--
--><li><a id="now" href="{{url_for('search.search')}}">&#128269;</a></li>
{% endblock %}

{% block section %}
<div>
<h2 class="manage">Manage <b>Employees </b><button type="button"
class="btn btn-success" data-toggle="modal"
data-target="#mymodal">ADD NEW EMPLOYEE</button></h2>


{% with messages = get_flashed_messages() %}
    {% if messages %}
        {% for message in messages %}
            <div class="alert alert-success alert-dismissable" role="alert">

                <button type="button" class="close" data-dismiss="alert" aria-label="close">
                    <span aria-hidden="true">x</span>
                </button>

                <h4 class="message-flash"><b>{{ message }}</b></h4>
            </div>

        {% endfor %}
    {% endif %}
{% endwith %}
</div>

<hr>

<form action="{{url_for('search.search_date')}}" class="form-dob" method="POST">
	<label for="date-dob">Input employee <b>DOB</b>:</label>
	<input type="date" name="date-dob" id="date-dob" required="">
	<input type="submit" class="" name="">
</form>

{% if emp_dob_date %}
    <table>
        <tr>
        <th>Department</th>
        <th>Employee</th>
        <th>DOB</th>
        <th>Salary</th>
        <th>Action</th>
    </tr>

    {% for employee in emp_dob_date %}
    <tr>
        <td>{{employee.dep_name}}</td>
        <td>{{employee.name}}</td>
        <td>{{employee.dob}}</td>
        <td>{{employee.salary}}</td>
        <td class="edit">
            <a href="" class="btn btn-warning btn-xs" data-toggle="modal" data-target="#modaledit{{employee.id}}">EDIT</a>
            <a href="/delete/{{employee.id}}" class="btn btn-danger btn-xs" onclick="return confirm('Are you sure to delete this user?')">DELETE</a>
        </td>
    </tr>
    {% endfor %}
</table>
{% endif %}

<hr>

<form action="{{url_for('search.search_period')}}" class="form-dob" method="POST">
	<label for="period">Input employee <b>DOB in the period between dates</b>:</label>
	<input type="date" name="period-1" id="period" required="">
	<input type="date" name="period-2" id="period" required="">
	<input type="submit" id="period" class="" name="">
</form>

{% if emp_dob_period %}
    <table>
        <tr>
        <th>Department</th>
        <th>Employee</th>
        <th>DOB</th>
        <th>Salary</th>
        <th>Action</th>
    </tr>

    {% for employee in emp_dob_period %}
    <tr>
        <td>{{employee.dep_name}}</td>
        <td>{{employee.name}}</td>
        <td>{{employee.dob}}</td>
        <td>{{employee.salary}}</td>
        <td class="edit">
            <a href="" class="btn btn-warning btn-xs" data-toggle="modal" data-target="#modaledit{{employee.id}}">EDIT</a>
            <a href="/delete/{{employee.id}}" class="btn btn-danger btn-xs" onclick="return confirm('Are you sure to delete this user?')">DELETE</a>
        </td>
    </tr>
    {% endfor %}
</table>
{% endif %}

<hr>

<div id="mymodal" class="modal fade" role="dialog">
   <div class="modal-dialog">
      <div class="modal-content">

         <div class="modal-header">
            <h4 class="modal-title">Add Employee</h4>
         </div>

         <div class="modal-body">
            <form action="{{url_for('search.insert')}}" method="POST">

               <div class="form-group">
                  <label for="name">Name:</label>
                  <input type="text" id="name" class="form-control" name="name"
                         required="" pattern="^[A-Za-zА-Яа-яЁё\s]+$" placeholder="Ivan Ivanov">
               </div>

                <div class="form-group">
                  <label for="department">Department name:</label>
                  <select name="department" id="department" required class="form-control">
                        {% for dep in all_dep %}
                            <option value="{{dep.department}}">{{dep.department}}</option>
                        {% endfor %}
                    </select>
                </div>

                <div class="form-group">
                  <label for="dob-emp">DOB:</label>
                  <input type="date" class="form-control" name="dob-emp" id="dob-emp" required="">
               </div>

                <div class="form-group">
                  <label for="salary">Salary:</label>
                  <input type="number" class="form-control" name="salary" id="salary"
                         required="" min="5000" max="99999" placeholder="7500">
               </div>

               <div class="form-group">
                  <button class="btn btn-primary" type="submit">Add Employee</button>
               </div>

            </form>
         </div>

         <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
         </div>

      </div>
   </div>
</div>

{% if emp_dob_date %}
    {% for employee in emp_dob_date %}
        {% include 'edit.html' %}
    {% endfor %}
{% endif %}

{% if emp_dob_period %}
    {% for employee in emp_dob_period %}
        {% include 'edit.html' %}
    {% endfor %}
{% endif %}

{% endblock %}